/*
 DJ Shield for Arduino - DEMO program
 by dm9 records

  * Turns a pots, shows binaly values on LEDs 
    and Send Data on USB-Serial(9600bps).
    
  more infomation : http://www.dm9records.com
  
  This code and schmantic is in Creative Commons 2.5 Share/Alike.
*/

//MIDI Channel
#define MIDI_CHANNEL 1

//MIDI CC No
#define A_HIGH 11
#define A_MID 12
#define A_LOW 13
#define A_VOL 14
#define B_HIGH 15
#define B_MID 16
#define B_LOW 17
#define B_VOL 18
#define POT_A 19
#define POT_B 20
#define POT_FX 21
#define JOY_UP 22
#define JOY_DOWN 23
#define JOY_LEFT 24
#define JOY_RIGHT 25

//analog_pin
#define B_HIGH_PIN 0
#define A_HIGH_PIN 1
#define JOY_V 2
#define JOY_H 3
#define FX 4
#define OUT4051 5
//digital
//LED D5-D12
//#define JOY_SW 13
//                    0     1     2     3     4     5     6     7     8      9      10     11       12     13        14
const int CCNo[15] = {A_MID,B_LOW,A_VOL,POT_A,A_LOW,B_VOL,B_MID,POT_B,B_HIGH,A_HIGH,POT_FX,JOY_DOWN,JOY_UP,JOY_RIGHT,JOY_LEFT};

int pastVal[15] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

int joyOffset[2] = {0,0};

void setup(){ 
  DDRD = DDRD | B11111100;
  DDRB = B011111;
  digitalWrite(13,HIGH);
  Serial.begin(57600);
  
  for(int i=0;i<16;i++){
    joyOffset[0] += analogRead(JOY_V);
    joyOffset[1] += analogRead(JOY_H);
    
    for(int i=0;i<8;i++){
      pastVal[i] += read4051(i);
    }
    
    pastVal[8] += (1023 - analogRead(B_HIGH_PIN)) >> 3;
    pastVal[9] += (1023 - analogRead(A_HIGH_PIN)) >> 3;
    pastVal[10] += (1023 - analogRead(FX)) >> 3;
  }
  
  joyOffset[0] = joyOffset[0] >> 4;
  joyOffset[1] = joyOffset[1] >> 4;
  for(int i=0;i<11;i++){
      pastVal[i] = pastVal[i]>>4;
  }
}

void loop(){
  int tempVal[15] = {0,0,0,0,0,0,0,0,0,0,0,0,0};
  long tempJoyVal[2] = {0,0};
  
  for(int j=0;j<16;j++){
    for(int i=0;i<8;i++){
      tempVal[i] += read4051(i);
    }
      tempVal[8] += (1023 - analogRead(B_HIGH_PIN)) >> 3;
      tempVal[9] += (1023 - analogRead(A_HIGH_PIN)) >> 3;
      tempVal[10] += (1023 - analogRead(FX)) >> 3;
    for(int i=0;i<2;i++){
      tempJoyVal[i] += readJoyXY(i);
    }
  }
  
  for(int i=0;i<2;i++){
    tempJoyVal[i] = tempJoyVal[i]>>4;
    tempVal[11+i*2] = map(tempJoyVal[i],0,joyOffset[i],127,0);
    tempVal[12+i*2] = map(tempJoyVal[i],joyOffset[i],1023,0,127);
  }
  
  
  for(int i=0;i<11;i++){
      tempVal[i] = tempVal[i]>>4;
      sendCCDEMO(i,tempVal[i]);
  }
  for(int i=11;i<15;i++){
      if(tempVal[i]<0){
        tempVal[i] = 0;
      }
      sendCCDEMO(i,tempVal[i]);
  }
}

int read4051(int pinNo){
  int return_val;
  pinNo = pinNo << 2;
  PORTD = PORTD & B11100011;
  PORTD = PORTD | pinNo;
  return_val = analogRead(OUT4051);
  return (1023 - return_val)>>3;
}

int readJoyXY(int pinNo){
  int return_val;
  return_val = analogRead(pinNo+2);
  return return_val;
}

void led_A(int val){
  int temp = map(val,0,127,0,15);
  PORTD = PORTD & B00011111;
  PORTB = PORTB & B111110;
  PORTD = PORTD | (temp << 5);
  PORTB = PORTB | (temp >> 3);
}

void led_B(int val){
  int temp = map(val,0,127,0,15);
  PORTB = PORTB & B100001;
  PORTB = PORTB | (temp << 1);
}

void sendCCDEMO(int no,int val){
  if(val != pastVal[no]){
    Serial.print(CCNo[no]);
    Serial.print(" : ");
    Serial.println(val);
    pastVal[no] = val;
    switch(no){
      case 9:
      case 0:
      case 4:
      case 2:
      case 3:
      case 12:
      case 11:
        led_A(val);
        break;
      case 1:
      case 5:
      case 6:
      case 7:
      case 8:
      case 13:
      case 14:
        led_B(val);
        break;
      case 10:
        led_A(val);
        led_B(val);
        break;
      default:
        break;
    }
  }
}
